// CalDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "CalDlg.h"

#define	__CALDLG__
#include "DllCOM.h"
#undef __CALDLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCalDlg dialog

extern int gblPortNo;
extern float gblCurWL;
extern CString gblsCurWL;


CCalDlg::CCalDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCalDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCalDlg)
	m_lCalTOut = 2;
	m_iCalCancel = 0;
	m_iCalStatus = 0;
	m_sCalCurrentWL = _T("");
	m_sCalDesiredWL = _T("");
	//}}AFX_DATA_INIT
}


void CCalDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCalDlg)
	DDX_Control(pDX, IDC_COUNT2MIN, m_eCount);
	DDX_Control(pDX, IDC_WAIT2MIN, m_sWait2Min);
	DDX_Control(pDX, IDC_SEC, m_sSec);
	DDX_Control(pDX, IDCANCEL, m_cExit);
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Text(pDX, IDC_CALTOUT, m_lCalTOut);
	DDV_MinMaxLong(pDX, m_lCalTOut, 0, 3599);
	DDX_Text(pDX, IDC_CALCANCEL, m_iCalCancel);
	DDX_Text(pDX, IDC_CALSTATUS, m_iCalStatus);
	DDX_Text(pDX, IDC_CALCURRENTWL, m_sCalCurrentWL);
	DDX_Text(pDX, IDC_CALDESIREDWL, m_sCalDesiredWL);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCalDlg, CDialog)
	//{{AFX_MSG_MAP(CCalDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCalDlg message handlers

BOOL CCalDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);

	m_sCalCurrentWL=gblsCurWL;
	m_sCalDesiredWL=gblsCurWL;
	m_iCalStatus = 0;
	m_iCalCancel = 0;
	//m_eCount.SetWindowText("0");
	m_eCount.ShowWindow(FALSE);
	m_sSec.ShowWindow(FALSE);
	//m_sWait2Min.ShowWindow(FALSE);


	// Update the dialog
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CCalDlg::OnOk() 
{
	// TODO: Add your control notification handler code here
	//0: no error, 1: Not echo, 2: Port not open
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn, iTimeout;
	long lWavelength;
	// Update the variable
	UpdateData(TRUE);
	iTimeout=(int)m_lCalTOut;
	
	lWavelength	= (atol(m_sCalDesiredWL)*100);
	//DKCalibrate(int iTimeout, BYTE *bReturn, long lWavelength)
	iRtn=DKCalibrate(iTimeout*4, StatusCancel, lWavelength);	

	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];

	m_iCalStatus=StatusB;
	m_iCalCancel=CancelB;
	// Update dialog
	UpdateData(FALSE);

	if (StatusB<=127)
	{
		gblCurWL = (float)atof(m_sCalDesiredWL);
		gblsCurWL.Format("%10.2f", (float)gblCurWL);
		m_sCalCurrentWL = gblsCurWL;
		m_sCalDesiredWL = gblsCurWL;
		// TRUE: Update the variable
		UpdateData(FALSE);
	}
	else
	{
		if ( (StatusB & 64)==0)
		MessageBox("An error has occurred !",
			"Status != 128",
			MB_ICONSTOP);
		else
			gblCurWL = (float)atof(m_sCalDesiredWL);
	}
	if(StatusB==1)
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}

	//m_eCount.ShowWindow(TRUE);
	//m_sSec.ShowWindow(TRUE);
	//m_sWait2Min.ShowWindow(TRUE);
	
	// TRUE: Update the variable
	UpdateData(FALSE);
/*
	CString strTmp;
	strTmp.Format(_T("SendData 1\n"));
	AfxMessageBox(strTmp);	
*/
/*
	CString str;
	for(int j=0; j<150; j++)
	{
		spSleep(10);
		str.Format("Counter: %d",j);
		m_eCount.SetWindowText(str);
		// TRUE: Update the variable
		UpdateData(FALSE);
	}
*/
	m_cOK.EnableWindow(TRUE);
	
}

