// DllCOM.h : Spectral Products Serial Communications DLL function call


#ifndef __DLL_COM__
#define __DLL_COM__


#define DLLIMPORT extern "C" __declspec(dllimport)
#ifdef	__DKA__
# define	CALLTYPE	
#else
# define	CALLTYPE	__stdcall
#endif

DLLIMPORT int CALLTYPE openCOM(int nPort, int nBaud);
DLLIMPORT int CALLTYPE closeCOM();
DLLIMPORT void CALLTYPE spSleep(long lMilSec);
DLLIMPORT int CALLTYPE DKCalibrate(int iTimeout, BYTE *bReturn, long lWavelength);
DLLIMPORT int CALLTYPE DKEcho(int Timeout);
DLLIMPORT int CALLTYPE DKSerialQ(int iTimeout, BYTE *bReturn, char *cSerial);
DLLIMPORT int CALLTYPE DKGrtIdQ(int iTimeout, BYTE *bReturn, BYTE *bData);
DLLIMPORT int CALLTYPE DKWaveQ(int iTimeout, BYTE *bReturn, long *lData);
DLLIMPORT int CALLTYPE DKGoto(int iTimeout, BYTE *bReturn, long lWavelength);
DLLIMPORT int CALLTYPE DKGotoA(int iTimeout, BYTE *bStatus, long lWavelength);
DLLIMPORT int CALLTYPE DKGetBytes(int iTimeout, BYTE *bByte, int nByte);
DLLIMPORT int CALLTYPE DKSendBytes(int iTimeout, BYTE *bByte, int nByte);
DLLIMPORT int CALLTYPE DKScan(int iTimeout, BYTE *bReturn, long lWavelength);
DLLIMPORT int CALLTYPE DKSSpeed(int iTimeout, BYTE *bReturn, long lSSpeed);
DLLIMPORT int CALLTYPE DKSSpeedQ(int iTimeout, BYTE *bReturn, long *lSSpeed);
DLLIMPORT int CALLTYPE DKSltAdjCal(int iTimeout, BYTE *bReturn, int iSlitB, int iSlitW);
DLLIMPORT int CALLTYPE DKSlit240Q(int iTimeout, BYTE *bReturn, int *iS1Data, int *iS2Data);
DLLIMPORT int CALLTYPE DKSlit242Q(int iTimeout, BYTE *bReturn, int *iS1Data, int *iS2Data, int *iS3Data);
DLLIMPORT int CALLTYPE DKGrtSel(int iTimeout, BYTE *bReturn, int iGrtB);
DLLIMPORT int CALLTYPE DKReset(int iTimeout);
DLLIMPORT int CALLTYPE DKNovramRd(int iTimeout, BYTE *bReturn, long *lData, int iAddr);
DLLIMPORT int CALLTYPE DKNovramWr(int iTimeout, BYTE *bReturn, long lData, int iAddr);
DLLIMPORT int CALLTYPE DKMemoryRd(int iTimeout, BYTE *bReturn, int *iData, long lAddr);
DLLIMPORT int CALLTYPE DKZero(int iTimeout, BYTE *bReturn, int iTurretB);
DLLIMPORT int CALLTYPE DKFilter(int iTimeout, BYTE *bReturn, int iFilterB);
DLLIMPORT int CALLTYPE DKSlotWidth(int iTimeout, BYTE *bReturn, long *lSlotW);
DLLIMPORT int CALLTYPE DKStepDnUp(int iTimeout, BYTE *bReturn, int iStepB);
DLLIMPORT int CALLTYPE DKSlewScanDnUp(int iTimeout, BYTE *bReturn, int iStepB);
DLLIMPORT int CALLTYPE DKFmCal(int iTimeout, BYTE *bReturn);
DLLIMPORT int CALLTYPE DKFmHome(int iTimeout, BYTE *bReturn);
DLLIMPORT int CALLTYPE DKFmLED(int iTimeout, BYTE *bReturn, int iLEDb);
DLLIMPORT int CALLTYPE DKFmMove(int iTimeout, BYTE *bReturn, int iMoveB);
DLLIMPORT int CALLTYPE DKFmQ(int iTimeout, BYTE *bReturn, int *iFmQ);
DLLIMPORT int CALLTYPE DKFmStepQ(int iTimeout, BYTE *bReturn, long *lFmSteps);
DLLIMPORT int CALLTYPE DKFmFlip(int iTimeout, BYTE *bReturn, int iFlipB);
DLLIMPORT int CALLTYPE DKFlushRcv(int iTimeout);



#endif
