// FmCalibrateDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "FmCalibrateDlg.h"

#define	__FMCALIBRATEDLG__
#include "DllCOM.h"
#undef __FMCALIBRATEDLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFmCalibrateDlg dialog

extern int gblPortNo;
extern int gblLED;		//0:Off,  1:On
extern int gblFmPos;	//0:Mono, 1:Spec.
long gbllFMmono, gbllFMspec;


CFmCalibrateDlg::CFmCalibrateDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFmCalibrateDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFmCalibrateDlg)
	m_lOffset1 = 0;
	m_lOffset2 = 0;
	m_lSteps = 0;
	//}}AFX_DATA_INIT
}


void CFmCalibrateDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFmCalibrateDlg)
	DDX_Control(pDX, IDC_CANCEL, m_cExit);
	DDX_Control(pDX, IDC_UPM9, m_cUpM9);
	DDX_Control(pDX, IDC_UPM8, m_cUpM8);
	DDX_Control(pDX, IDC_UPM7, m_cUpM7);
	DDX_Control(pDX, IDC_DNM3, m_cDnM3);
	DDX_Control(pDX, IDC_DNM2, m_cDnM2);
	DDX_Control(pDX, IDC_DNM1, m_cDnM1);
	DDX_Control(pDX, IDC_CALIBRATE, m_cCalibrate);
	DDX_Text(pDX, IDC_FMOFFSET1, m_lOffset1);
	DDX_Text(pDX, IDC_FMOFFSET2, m_lOffset2);
	DDX_Text(pDX, IDC_FMSTEPS, m_lSteps);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFmCalibrateDlg, CDialog)
	//{{AFX_MSG_MAP(CFmCalibrateDlg)
	ON_BN_CLICKED(IDC_CALIBRATE, OnCalibrate)
	ON_BN_CLICKED(IDC_DNM1, OnDnm1)
	ON_BN_CLICKED(IDC_DNM2, OnDnm2)
	ON_BN_CLICKED(IDC_DNM3, OnDnm3)
	ON_BN_CLICKED(IDC_UPM7, OnUpm7)
	ON_BN_CLICKED(IDC_UPM8, OnUpm8)
	ON_BN_CLICKED(IDC_UPM9, OnUpm9)
	ON_BN_CLICKED(IDC_CANCEL, OnCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFmCalibrateDlg message handlers


BOOL CFmCalibrateDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	// TODO: Add extra initialization here
	//0: no error, 1: Not echo, 2: Port not open
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn, iTimeout;
	long lData;
	// TODO: Add extra initialization here
	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);

	iTimeout=5;
	lData=0;
	//DKNovramRd(int iTimeout, BYTE *bReturn, long *lData, int iAddr)
	iRtn=DKNovramRd(iTimeout, StatusCancel, &lData, 3);
	gbllFMmono=lData;
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];
	iRtn=DKNovramRd(iTimeout, StatusCancel, &lData, 4);
	gbllFMspec=lData;
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];
	m_lOffset1 = gbllFMmono;
	m_lOffset2 = gbllFMspec;
	// FASLE Update the dialog
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

int CFmCalibrateDlg::MoveFm(int iMoveB)
{
	//0: no error, 1: Not echo, 2: Port not open
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn, iTimeout;
	long lFmSteps;
	iTimeout=2;
	//DKFmMove(int iTimeout, BYTE *bReturn, int iMoveB);
	iRtn=DKFmMove(iTimeout, StatusCancel, iMoveB);
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];
	//DKFmStepQ(int iTimeout, BYTE *bReturn, long *lFmSteps);
	iRtn=DKFmStepQ(iTimeout, StatusCancel, &lFmSteps);
	m_lSteps=lFmSteps;	
	// FASLE Update the dialog
	UpdateData(FALSE);
	return iRtn;
}

void CFmCalibrateDlg::OnDnm1() 
{
	// TODO: Add your control notification handler code here
	int iCmd;
	iCmd=81;
	MoveFm(iCmd);
}

void CFmCalibrateDlg::OnDnm2() 
{
	// TODO: Add your control notification handler code here
	int iCmd;
	iCmd=82;
	MoveFm(iCmd);	
}

void CFmCalibrateDlg::OnDnm3() 
{
	// TODO: Add your control notification handler code here
	int iCmd;
	iCmd=83;
	MoveFm(iCmd);	
}

void CFmCalibrateDlg::OnUpm7() 
{
	// TODO: Add your control notification handler code here
	int iCmd;
	iCmd=87;
	MoveFm(iCmd);	
}

void CFmCalibrateDlg::OnUpm8() 
{
	// TODO: Add your control notification handler code here
	int iCmd;
	iCmd=88;
	MoveFm(iCmd);	
}

void CFmCalibrateDlg::OnUpm9() 
{
	// TODO: Add your control notification handler code here
	int iCmd;
	iCmd=89;
	MoveFm(iCmd);	
}

void CFmCalibrateDlg::OnCalibrate() 
{
	// TODO: Add your control notification handler code here
	//0: no error, 1: Not echo, 2: Port not open
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn, iTimeout;
	long lData;
	iTimeout=2;
	iRtn=DKFmCal(iTimeout, StatusCancel);
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];
	//DKNovramRd(int iTimeout, BYTE *bReturn, long *lData, int iAddr)
	iRtn=DKNovramRd(iTimeout, StatusCancel, &lData, 3);
	gbllFMmono=lData;
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];
	iRtn=DKNovramRd(iTimeout, StatusCancel, &lData, 4);
	gbllFMspec=lData;
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];
	m_lOffset1 = gbllFMmono;
	m_lOffset2 = gbllFMspec;
	// FASLE Update the dialog
	UpdateData(FALSE);
}

void CFmCalibrateDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	closeCOM();	
	CDialog::OnCancel();
}


