// ScanDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "ScanDlg.h"

#define	__SCANDLG__
#include "DllCOM.h"
#undef __SCANDLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CScanDlg dialog

extern int gblPortNo;
extern float gblCurWL;
extern CString gblsCurWL;

CScanDlg::CScanDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScanDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScanDlg)
	m_iScanCancel = 0;
	m_iScanStatus = 0;
	m_lScanTOut = 2;
	m_sScanWL0 = _T("");
	m_sScanWL1 = _T("");
	//}}AFX_DATA_INIT
}


void CScanDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScanDlg)
	DDX_Control(pDX, IDCANCEL, m_cExit);
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Text(pDX, IDC_SCANCANCEL, m_iScanCancel);
	DDX_Text(pDX, IDC_SCANSTATUS, m_iScanStatus);
	DDX_Text(pDX, IDC_SCANTOUT, m_lScanTOut);
	DDV_MinMaxLong(pDX, m_lScanTOut, 0, 3599);
	DDX_Text(pDX, IDC_SCANWL0, m_sScanWL0);
	DDX_Text(pDX, IDC_SCANWL1, m_sScanWL1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScanDlg, CDialog)
	//{{AFX_MSG_MAP(CScanDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScanDlg message handlers

BOOL CScanDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);

	m_lScanTOut=200;	// Initialize to 200s.
	m_sScanWL0=gblsCurWL;
	m_iScanStatus = 0;
	m_iScanCancel = 0;
	m_sScanWL1=gblsCurWL;
	// Update the dialog
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CScanDlg::OnOk() 
{
	// TODO: Add your control notification handler code here
	// VB use time 100s. Use 2ms for Echo only
	//0: no error, 1: Not echo, 2: Port not open
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn, iTimeout;
	long lWavelength;
	// Update the variable
	UpdateData(TRUE);
	m_cOK.EnableWindow(FALSE);
	m_cExit.EnableWindow(FALSE);

	iTimeout=(int)m_lScanTOut;
	lWavelength	= (long)(atof(m_sScanWL1))*100;	
	
	iRtn=DKScan(iTimeout*4, StatusCancel, lWavelength);	
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];
	m_iScanStatus=StatusB;
	m_iScanCancel=CancelB;
	// Update dialog
	UpdateData(FALSE);

	if (StatusB<=127)
	{
		gblCurWL = (float)atof(m_sScanWL1);
		gblsCurWL.Format("%10.2f", (float)gblCurWL);
		m_sScanWL1 = gblsCurWL;
		m_sScanWL0 = gblsCurWL;
		// TRUE: Update the variable
		UpdateData(FALSE);
	}
	else
	{
		if ( (StatusB & 64)==0)
		MessageBox("An error has occurred !",
			"Status != 128",
			MB_ICONSTOP);
		else
			gblCurWL = (float)atof(m_sScanWL1);
	}
	
	if(StatusB==1)
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
	m_cOK.EnableWindow(TRUE);
	m_cExit.EnableWindow(TRUE);
}

void CScanDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	closeCOM();	
	CDialog::OnCancel();
}
