// SlitAdjDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "SlitAdjDlg.h"

#define	__SLITADJDLG__
#include "DllCOM.h"
#undef __SLITADJDLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSlitAdjDlg dialog

extern int gblPortNo;
extern int gblS1, gblS2, gblS3;


CSlitAdjDlg::CSlitAdjDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSlitAdjDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSlitAdjDlg)
	m_iSlitAdjCancel = 0;
	m_iSlitAdjStatus = 0;
	m_lSlitAdjTOut = 2;
	m_iSlitsAdj = 0;
	m_iSlit1Adj = 0;
	m_iSlit2Adj = 0;
	m_iSlitsButton1 = -1;
	//}}AFX_DATA_INIT
}


void CSlitAdjDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSlitAdjDlg)

	DDX_Text(pDX, IDC_SLITADJCANCEL, m_iSlitAdjCancel);
	DDX_Text(pDX, IDC_SLITADJSTATUS, m_iSlitAdjStatus);
	DDX_Text(pDX, IDC_SLITADJTOUT, m_lSlitAdjTOut);
	DDX_Text(pDX, IDC_SLITSADJ, m_iSlitsAdj);
	DDV_MinMaxInt(pDX, m_iSlitsAdj, 10, 5000);
	DDX_Text(pDX, IDC_SLIT1ADJ, m_iSlit1Adj);
	DDV_MinMaxInt(pDX, m_iSlit1Adj, 10, 5000);
	DDX_Text(pDX, IDC_SLIT2ADJ, m_iSlit2Adj);
	DDX_Radio(pDX, IDC_SLITSBUTTON1, m_iSlitsButton1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSlitAdjDlg, CDialog)
	//{{AFX_MSG_MAP(CSlitAdjDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	ON_BN_CLICKED(IDC_SLITSBUTTON2, OnSlitsbutton2)
	ON_BN_CLICKED(IDC_SLITSBUTTON3, OnSlitsbutton3)
	ON_BN_CLICKED(IDC_SLITSBUTTON1, OnSlitsbutton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSlitAdjDlg message handlers

BOOL CSlitAdjDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);

	// m_iSlitAdj[3]	Slits:0, S1: 1, S2: 2
	m_iSlitAdj[0].SubclassDlgItem(IDC_SLITSADJ, this);
	m_iSlitAdj[1].SubclassDlgItem(IDC_SLIT1ADJ, this);
	m_iSlitAdj[2].SubclassDlgItem(IDC_SLIT2ADJ, this);

	m_iSlitsButton1=0;
	
	m_iSlitsAdj = gblS2;
	m_iSlit1Adj = gblS1;
	m_iSlit2Adj = gblS2;
	// Update the dialog
	UpdateData(FALSE);
	OnSlitsbutton1();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CSlitAdjDlg::OnSlitsbutton1() 
{
	// TODO: Add your control notification handler code here
		m_iSlitAdj[0].EnableWindow(TRUE);
		m_iSlitAdj[1].EnableWindow(FALSE);
		m_iSlitAdj[2].EnableWindow(FALSE);
		m_iSlitsButton1=0;
}


void CSlitAdjDlg::OnSlitsbutton2() 
{
	// TODO: Add your control notification handler code here
		m_iSlitAdj[0].EnableWindow(FALSE);
		m_iSlitAdj[1].EnableWindow(TRUE);
		m_iSlitAdj[2].EnableWindow(FALSE);
		m_iSlitsButton1=1;
}


void CSlitAdjDlg::OnSlitsbutton3() 
{
	// TODO: Add your control notification handler code here
		m_iSlitAdj[0].EnableWindow(FALSE);
		m_iSlitAdj[1].EnableWindow(FALSE);
		m_iSlitAdj[2].EnableWindow(TRUE);
		m_iSlitsButton1=2;
}


void CSlitAdjDlg::OnOk() 
{
	// TODO: Add your control notification handler code here
	//0: no error, 1: Not echo, 2: Port not open	
	BYTE IDcmd, StatusB, CancelB;
	BYTE StatusCancel[2]; 
	int iRtn, iTimeout, iSlitNew;

	// Update the variable
	UpdateData(TRUE);
	iTimeout=(int)m_lSlitAdjTOut;		//2s

	SetDlgItemText(IDC_SLITADJSTATUS,"0");
	SetDlgItemText(IDC_SLITADJCANCEL,"0");

	switch(m_iSlitsButton1)
	{
	case 0:
		IDcmd=14;	// All Slits
		iSlitNew = m_iSlitsAdj;
		break;
	case 1:
		IDcmd=31;	// Entrance slit (S1)
		iSlitNew = m_iSlit1Adj;
		break;
	case 2:
		IDcmd=32;	// Exit slit (S2)
		iSlitNew = m_iSlit2Adj;
		break;
	default:
		IDcmd=14;	// All Slits
		iSlitNew = m_iSlitsAdj;
		break;
	}
	// Update the variable
	UpdateData(TRUE);

	//DKSltAdjCal(int iTimeout, BYTE *bReturn, int iSlitB, int iSlitW);
	iRtn=DKSltAdjCal(iTimeout, StatusCancel, IDcmd, iSlitNew);	

	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];

	m_iSlitAdjStatus=StatusB;
	m_iSlitAdjCancel=CancelB;
	// Update dialog
	UpdateData(FALSE);

	if (StatusB<=127)
	{
		UpdateGblSlit( m_iSlitsButton1, iSlitNew );
	}
	else
	{
		if ( (StatusB & 64)==0)
		MessageBox("An error has occurred !",
			"Status != 128",
			MB_ICONSTOP);
		else
			UpdateGblSlit( m_iSlitsButton1, iSlitNew );
	}

	if(StatusB==1)
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}	

}


void CSlitAdjDlg::UpdateGblSlit(int SlitN, int SlitNew)
{
	switch(SlitN)
	{
	case 0:
		gblS1 = SlitNew;
		gblS2 = SlitNew;
		m_iSlit1Adj = SlitNew;
		m_iSlit2Adj = SlitNew;
		break;
	case 1:
		gblS1 = SlitNew;
		break;
	case 2:
		gblS2 = SlitNew;
		m_iSlitsAdj = SlitNew;
		break;
	default:
		gblS1 = SlitNew;
		gblS2 = SlitNew;
		m_iSlit1Adj = SlitNew;
		m_iSlit2Adj = SlitNew;
		break;
	}
	// Update the dialog
	UpdateData(FALSE);
}

void CSlitAdjDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	closeCOM();	
	CDialog::OnCancel();
}
