// SlitCalDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "SlitCalDlg.h"

#define	__SLITCALDLG__
#include "DllCOM.h"
#undef __SLITCALDLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSlitCalDlg dialog

extern int gblPortNo;
extern int gblS1, gblS2, gblS3;


CSlitCalDlg::CSlitCalDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSlitCalDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSlitCalDlg)
	m_iSlit1Cal = 0;
	m_iSlit2Cal = 0;
	m_iSlitCalBtn1 = -1;
	m_iSlitCalCancel = 0;
	m_iSlitCalStatus = 0;
	m_lSlitCalTOut = 2;
	//}}AFX_DATA_INIT
}


void CSlitCalDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSlitCalDlg)
	DDX_Control(pDX, IDC_OK, m_cOK);

	DDX_Text(pDX, IDC_SLIT1CAL, m_iSlit1Cal);
	DDX_Text(pDX, IDC_SLIT2CAL, m_iSlit2Cal);
	DDX_Radio(pDX, IDC_SLITCALBTN1, m_iSlitCalBtn1);
	DDX_Text(pDX, IDC_SLITCALCANCEL, m_iSlitCalCancel);
	DDX_Text(pDX, IDC_SLITCALSTATUS, m_iSlitCalStatus);
	DDX_Text(pDX, IDC_SLITCALTOUT, m_lSlitCalTOut);
	DDV_MinMaxLong(pDX, m_lSlitCalTOut, 0, 3599);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSlitCalDlg, CDialog)
	//{{AFX_MSG_MAP(CSlitCalDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	ON_BN_CLICKED(IDC_SLITCALBTN1, OnSlitcalbtn1)
	ON_BN_CLICKED(IDC_SLITCALBTN2, OnSlitcalbtn2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSlitCalDlg message handlers

BOOL CSlitCalDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);


	// m_iSlitAdj[2]	S1: 0, S2: 1
	m_iSlitCal[0].SubclassDlgItem(IDC_SLIT1CAL, this);
	m_iSlitCal[1].SubclassDlgItem(IDC_SLIT2CAL, this);

	m_iSlitCalBtn1=0;

	m_iSlit1Cal = gblS1;
	m_iSlit2Cal = gblS2;
	// FASLE Update the dialog
	UpdateData(FALSE);
	OnSlitcalbtn1();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSlitCalDlg::OnSlitcalbtn1() 
{
	// TODO: Add your control notification handler code here
		m_iSlitCal[0].EnableWindow(TRUE);
		m_iSlitCal[1].EnableWindow(FALSE);
		m_iSlitCalBtn1=0;
}

void CSlitCalDlg::OnSlitcalbtn2() 
{
	// TODO: Add your control notification handler code here
		m_iSlitCal[0].EnableWindow(FALSE);
		m_iSlitCal[1].EnableWindow(TRUE);
		m_iSlitCalBtn1=1;
}

void CSlitCalDlg::OnOk() 
{
	// TODO: Add your control notification handler code here
	//0: no error, 1: Not echo, 2: Port not open	
	BYTE IDcmd, StatusB, CancelB;
	BYTE StatusCancel[2]; 
	int iRtn, iTimeout, iSlitNew;

	// Update the variable
	UpdateData(TRUE);
	iTimeout=(int)m_lSlitCalTOut;		//2s

	SetDlgItemText(IDC_SLITADJSTATUS,"0");
	SetDlgItemText(IDC_SLITADJCANCEL,"0");

	switch(m_iSlitCalBtn1)
	{
	case 0:
		IDcmd=22;	// Entrance slit (S1)
		iSlitNew = m_iSlit1Cal;
		break;
	case 1:
		IDcmd=23;	// Exit slit (S2)
		iSlitNew = m_iSlit2Cal;
		break;
	default:
		IDcmd=23;	// Exit slit (S2)
		iSlitNew = m_iSlit2Cal;
		break;
	}
	// Update the variable
	UpdateData(TRUE);
	//DKSltAdjCal(int iTimeout, BYTE *bReturn, int iSlitB, int iSlitW);
	iRtn=DKSltAdjCal(iTimeout, StatusCancel, IDcmd, iSlitNew);	

	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];

	m_iSlitCalStatus=StatusB;
	m_iSlitCalCancel=CancelB;
	// Update dialog
	UpdateData(FALSE);

	if (StatusB<=127)
	{
		UpdateGblSlit( m_iSlitCalBtn1, iSlitNew );
	}
	else
	{
		if ( (StatusB & 64)==0)
		MessageBox("An error has occurred !",
			"Status != 128",
			MB_ICONSTOP);
		else
			UpdateGblSlit( m_iSlitCalBtn1, iSlitNew );
	}

	if(StatusB==1)
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}	
}


void CSlitCalDlg::UpdateGblSlit(int SlitN, int SlitNew)
{
	switch(SlitN)
	{
	case 0:
		gblS1 = SlitNew;
		break;
	case 1:
		gblS2 = SlitNew;
		break;
	default:
		gblS2 = SlitNew;
		break;
	}
	// Update the dialog
	UpdateData(FALSE);
}

void CSlitCalDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	closeCOM();	
	CDialog::OnCancel();
}
