// ZeroDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "ZeroDlg.h"

#define	__ZERODLG__
#include "DllCOM.h"
#undef __ZERODLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CZeroDlg dialog

extern int gblPortNo;
extern float gblCurWL;
extern CString gblsCurWL;
extern long gblNGrtSelted;	//Number of grating selected.

// global, declaration in this file
int StepFrom0M1;


CZeroDlg::CZeroDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CZeroDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CZeroDlg)
	m_iOffsetM1 = 0;
	m_iStepM1 = 0;
	m_iZeroCancel = 0;
	m_iZeroStatus = 0;
	m_lZeroTOut = 2;
	//}}AFX_DATA_INIT
}


void CZeroDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CZeroDlg)
	DDX_Control(pDX, IDC_ZERO, m_cOK);
	DDX_Control(pDX, IDCANCEL, m_cExit);
	DDX_Control(pDX, IDC_STEPDNM1, m_cStepDnM1);
	DDX_Control(pDX, IDC_STEPUPM1, m_cStepUpM1);
	DDX_Text(pDX, IDC_OFFSETM1, m_iOffsetM1);
	DDV_MinMaxInt(pDX, m_iOffsetM1, 0, 65535);
	DDX_Text(pDX, IDC_STEPM1, m_iStepM1);
	DDX_Text(pDX, IDC_ZEROCANCEL, m_iZeroCancel);
	DDX_Text(pDX, IDC_ZEROSTATUS, m_iZeroStatus);
	DDX_Text(pDX, IDC_ZEROTOUT, m_lZeroTOut);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CZeroDlg, CDialog)
	//{{AFX_MSG_MAP(CZeroDlg)
	ON_BN_CLICKED(IDC_ZERO, OnZero)
	ON_BN_CLICKED(IDC_STEPUPM1, OnStepupm1)
	ON_BN_CLICKED(IDC_STEPDNM1, OnStepdnm1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZeroDlg message handlers


BOOL CZeroDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);

	StepFrom0M1 = 0;

	WORD OffsetM1;

	Queries( &OffsetM1 );
	m_iOffsetM1 = OffsetM1;
	// Updata the dialog
	UpdateData(FALSE);

	if(gblCurWL)
	{
		if(GotoZero()==0)
			gblCurWL=0;
	}


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CZeroDlg::OnZero() 
{
	// TODO: Add your control notification handler code here
	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred.	
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn, iTimeout;
	BYTE iTurretB;

	// Update the variable
	UpdateData(TRUE);

	iTimeout=m_lZeroTOut;

	SetDlgItemText(IDC_ZEROSTATUS,"0");
	SetDlgItemText(IDC_ZEROCANCEL,"0");
	
	iTurretB=1;

	//DKZero(int iTimeout, BYTE *bReturn, int iTurretB);
	iRtn=DKZero(iTimeout, StatusCancel, iTurretB);
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];
		m_iZeroStatus=StatusB;
		m_iZeroCancel=CancelB;
		// FALSE: Update dialog
		UpdateData(FALSE);


	if(iRtn)
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
	else
	{
		WORD OffsetM1;
		Queries( &OffsetM1 );
		m_iOffsetM1 = OffsetM1;
		StepFrom0M1=0;
		m_iStepM1=0;
		// Update dialog
		UpdateData(FALSE);
	}
}


void CZeroDlg::OnCancel() 
{
	// TODO: Add extra cleanup here

	if(StepFrom0M1)
	{
		if(GotoZero()==0)
			gblCurWL=0;
	}
	closeCOM();
	CDialog::OnCancel();
}



int CZeroDlg::GotoZero()
{
	//0: no error, 1: Not echo, 2: Port not open
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn, iTimeout;
	long lWavelength;
	
	iTimeout=5;
	lWavelength=0;
	iRtn=DKGoto(iTimeout, StatusCancel, lWavelength);

	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];
	
	if(iRtn)
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);

	return iRtn;
}


void CZeroDlg::Queries(WORD *OffsetM1)
{
	BYTE MIndex;	// The index of current grating select.
	MIndex=gblNGrtSelted - 1;	//Number of grating selected.
	
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int AddrI, iTimeout, iRtn;
	long lData;

	iTimeout=2;
	AddrI=14 + MIndex; 
	//DKNovramRd(int iTimeout, BYTE *bReturn, long *lData, int iAddr);
	iRtn=DKNovramRd(2, StatusCancel, &lData, AddrI);
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];
	*OffsetM1 = (WORD)lData;

	if(iRtn)
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
}


void CZeroDlg::OnStepupm1() 
{
	// TODO: Add your control notification handler code here
	if(StepUpDn(7) == 0)
		m_iStepM1 = ++StepFrom0M1;
	// Update the dialog
	UpdateData(FALSE);
}


void CZeroDlg::OnStepdnm1() 
{
	// TODO: Add your control notification handler code here
	if(StepUpDn(1) == 0)
		m_iStepM1 = --StepFrom0M1;
	// Update the dialog
	UpdateData(FALSE);
}


int CZeroDlg::StepUpDn(BYTE Cmd)
{
	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred.
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];	
	int iRtn, iTimeout;

	iTimeout = 5;		//2s
	//DKStepDnUp(int iTimeout, BYTE *bReturn, int iStepB);
	iRtn=DKStepDnUp(iTimeout, StatusCancel, Cmd);
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];

	if(iRtn)
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);

	return iRtn;
}

